POST /_snapshot/{repository}/{snapshot}/_restore

Restore a snapshot of a cluster or data streams and indices.

You can restore a snapshot only to a running cluster with an elected master node. The snapshot repository must be registered and available to the cluster. The snapshot and cluster versions must be compatible.

To restore a snapshot, the cluster's global metadata must be writable. Ensure there are't any cluster blocks that prevent writes. The restore operation ignores index blocks.

Before you restore a data stream, ensure the cluster contains a matching index template with data streams enabled. To check, use the index management feature in Kibana or the get index template API:

GET _index_template/*?filter_path=index_templates.name,index_templates.index_template.index_patterns,index_templates.index_template.data_stream

If no such template exists, you can create one or restore a cluster state that contains one. Without a matching index template, a data stream can't roll over or create backing indices.

If your snapshot contains data from App Search or Workplace Search, you must restore the Enterprise Search encryption key before you restore the snapshot.

Required authorization

  • Cluster privileges: manage
More about restoring a snapshot

Path parameters

  • repository string Required

    The name of the repository to restore a snapshot from.

  • snapshot string Required

    The name of the snapshot to restore.

Query parameters

  • master_timeout string

    The period to wait for the master node. If the master node is not available before the timeout expires, the request fails and returns an error. To indicate that the request should never timeout, set it to -1.

    Values are -1 or 0.

    External documentation
  • wait_for_completion boolean

    If true, the request returns a response when the restore operation completes. The operation is complete when it finishes all attempts to recover primary shards for restored indices. This applies even if one or more of the recovery attempts fail.

    If false, the request returns a response when the restore operation initializes.

application/json

Body

  • feature_states array[string]

    The feature states to restore. If include_global_state is true, the request restores all feature states in the snapshot by default. If include_global_state is false, the request restores no feature states by default. Note that specifying an empty array will result in the default behavior. To restore no feature states, regardless of the include_global_state value, specify an array containing only the value none (["none"]).

  • ignore_index_settings array[string]

    The index settings to not restore from the snapshot. You can't use this option to ignore index.number_of_shards.

    For data streams, this option applies only to restored backing indices. New backing indices are configured using the data stream's matching index template.

  • ignore_unavailable boolean

    If true, the request ignores any index or data stream in indices that's missing from the snapshot. If false, the request returns an error for any missing index or data stream.

    Default value is false.

  • include_aliases boolean

    If true, the request restores aliases for any restored data streams and indices. If false, the request doesn’t restore aliases.

    Default value is true.

  • include_global_state boolean

    If true, restore the cluster state. The cluster state includes:

    • Persistent cluster settings
    • Index templates
    • Legacy index templates
    • Ingest pipelines
    • Index lifecycle management (ILM) policies
    • Stored scripts
    • For snapshots taken after 7.12.0, feature states

    If include_global_state is true, the restore operation merges the legacy index templates in your cluster with the templates contained in the snapshot, replacing any existing ones whose name matches one in the snapshot. It completely removes all persistent settings, non-legacy index templates, ingest pipelines, and ILM lifecycle policies that exist in your cluster and replaces them with the corresponding items from the snapshot.

    Use the feature_states parameter to configure how feature states are restored.

    If include_global_state is true and a snapshot was created without a global state then the restore request will fail.

    Default value is false.

  • index_settings object

    Index settings to add or change in restored indices, including backing indices. You can't use this option to change index.number_of_shards.

    For data streams, this option applies only to restored backing indices. New backing indices are configured using the data stream's matching index template.

    Hide index_settings attributes Show index_settings attributes object
    • index object
    • mode string
    • routing_path string | array[string]

    • soft_deletes object
      Hide soft_deletes attributes Show soft_deletes attributes object
      • enabled boolean

        Indicates whether soft deletes are enabled on the index.

        Default value is true.

      • retention_lease object

        The maximum period to retain a shard history retention lease before it is considered expired. Shard history retention leases ensure that soft deletes are retained during merges on the Lucene index. If a soft delete is merged away before it can be replicated to a follower the following process will fail due to incomplete history on the leader.

    • sort object
      Hide sort attributes Show sort attributes object
    • number_of_shards number | string Generally available

      One of:

      Default value is 1.

      Default value is 1.

    • number_of_replicas number | string Generally available

      One of:

      Default value is 0.

      Default value is 0.

    • number_of_routing_shards number
    • check_on_startup string

      Values are true, false, or checksum.

    • codec string

      Default value is LZ4.

    • routing_partition_size number | string

    • load_fixed_bitset_filters_eagerly boolean

      Default value is true.

    • hidden boolean | string

      One of:

      Default value is false.

      Default value is false.

    • auto_expand_replicas string | null

      One of:

      Default value is false.

      A null value that is to be interpreted as an actual value, unless other uses of null that are equivalent to a missing value. It is used for exemple in settings, where using the NullValue for a setting will reset it to its default value.

    • merge object
      Hide merge attribute Show merge attribute object
      • scheduler object
    • refresh_interval string

      A duration. Units can be nanos, micros, ms (milliseconds), s (seconds), m (minutes), h (hours) and d (days). Also accepts "0" without a unit and "-1" to indicate an unspecified value.

      External documentation
    • max_result_window number

      Default value is 10000.0.

    • max_inner_result_window number

      Default value is 100.0.

    • max_rescore_window number

      Default value is 10000.0.

    • max_script_fields number

      Default value is 32.0.

    • max_ngram_diff number

      Default value is 1.0.

    • max_shingle_diff number

      Default value is 3.0.

    • blocks object
      Hide blocks attributes Show blocks attributes object
    • max_refresh_listeners number
    • analyze object

      Settings to define analyzers, tokenizers, token filters and character filters. Refer to the linked documentation for step-by-step examples of updating analyzers on existing indices.

      External documentation
      Hide analyze attribute Show analyze attribute object
    • highlight object
      Hide highlight attribute Show highlight attribute object
      • max_analyzed_offset number

        Default value is 1000000.0.

    • max_terms_count number

      Default value is 65536.0.

    • max_regex_length number

      Default value is 1000.0.

    • routing object
      Hide routing attributes Show routing attributes object
      • allocation object
      • rebalance object
    • gc_deletes string

      A duration. Units can be nanos, micros, ms (milliseconds), s (seconds), m (minutes), h (hours) and d (days). Also accepts "0" without a unit and "-1" to indicate an unspecified value.

      External documentation
    • default_pipeline string
    • final_pipeline string
    • lifecycle object
      Hide lifecycle attributes Show lifecycle attributes object
      • name string

        The name of the policy to use to manage the index. For information about how Elasticsearch applies policy changes, see Policy updates.

      • indexing_complete boolean | string

        Indicates whether or not the index has been rolled over. Automatically set to true when ILM completes the rollover action. You can explicitly set it to skip rollover.

      • origination_date number

        If specified, this is the timestamp used to calculate the index age for its phase transitions. Use this setting if you create a new index that contains old data and want to use the original creation date to calculate the index age. Specified as a Unix epoch value in milliseconds.

        Default value is 0.0.

      • parse_origination_date boolean

        Set to true to parse the origination date from the index name. This origination date is used to calculate the index age for its phase transitions. The index name must match the pattern .*-{date_format}-\d+, where the date_format is yyyy.MM.dd and the trailing digits are optional. An index that was rolled over would normally match the full format, for example logs-2016.10.31-000002). If the index name doesn’t match the pattern, index creation fails.

      • step object
      • rollover_alias string

        The index alias to update when the index rolls over. Specify when using a policy that contains a rollover action. When the index rolls over, the alias is updated to reflect that the index is no longer the write index. For more information about rolling indices, see Rollover.

        Default value is empty.

      • prefer_ilm boolean | string

        Preference for the system that manages a data stream backing index (preferring ILM when both ILM and DLM are applicable for an index).

        One of:

        Default value is true.

        Default value is true.

    • provided_name string
    • creation_date number | string

      One of:

      Time unit for milliseconds

    • creation_date_string string | number

      One of:

      Time unit for milliseconds

    • uuid string
    • version object
      Hide version attributes Show version attributes object
      • created string
      • created_string string
    • verified_before_close boolean | string

    • format string | number

    • max_slices_per_scroll number
    • translog object
      Hide translog attributes Show translog attributes object
      • sync_interval string

        How often the translog is fsynced to disk and committed, regardless of write operations. Values less than 100ms are not allowed.

        External documentation
      • durability string

        Whether or not to fsync and commit the translog after every index, delete, update, or bulk request.

        Values are request, REQUEST, async, or ASYNC.

      • flush_threshold_size number | string

        The translog stores all operations that are not yet safely persisted in Lucene (i.e., are not part of a Lucene commit point). Although these operations are available for reads, they will need to be replayed if the shard was stopped and had to be recovered. This setting controls the maximum total size of these operations, to prevent recoveries from taking too long. Once the maximum size has been reached a flush will happen, generating a new Lucene commit point.

      • retention object
    • query_string object
      Hide query_string attribute Show query_string attribute object
    • priority number | string

    • top_metrics_max_size number
    • analysis object
      Hide analysis attributes Show analysis attributes object
      • analyzer object
      • char_filter object
      • filter object
      • normalizer object
      • tokenizer object
    • settings object
    • time_series object
      Hide time_series attributes Show time_series attributes object
      • end_time string
      • start_time string
    • queries object
      Hide queries attribute Show queries attribute object
      • cache object
        Hide cache attribute Show cache attribute object
        • enabled boolean Required
    • similarity object

      Configure custom similarity settings to customize how search results are scored.

    • mapping object

      Enable or disable dynamic mapping for an index.

      Hide mapping attributes Show mapping attributes object
      • coerce boolean
      • total_fields object
        Hide total_fields attributes Show total_fields attributes object
        • limit
        • ignore_dynamic_beyond_limit
      • depth object
        Hide depth attribute Show depth attribute object
        • limit number

          The maximum depth for a field, which is measured as the number of inner objects. For instance, if all fields are defined at the root object level, then the depth is 1. If there is one object mapping, then the depth is 2, etc.

          Default value is 20.0.

      • nested_fields object
        Hide nested_fields attribute Show nested_fields attribute object
        • limit number

          The maximum number of distinct nested mappings in an index. The nested type should only be used in special cases, when arrays of objects need to be queried independently of each other. To safeguard against poorly designed mappings, this setting limits the number of unique nested types per index.

          Default value is 50.0.

      • nested_objects object
        Hide nested_objects attribute Show nested_objects attribute object
        • limit number

          The maximum number of nested JSON objects that a single document can contain across all nested types. This limit helps to prevent out of memory errors when a document contains too many nested objects.

          Default value is 10000.0.

      • field_name_length object
        Hide field_name_length attribute Show field_name_length attribute object
        • limit number

          Setting for the maximum length of a field name. This setting isn’t really something that addresses mappings explosion but might still be useful if you want to limit the field length. It usually shouldn’t be necessary to set this setting. The default is okay unless a user starts to add a huge number of fields with really long names. Default is Long.MAX_VALUE (no limit).

      • dimension_fields object
        Hide dimension_fields attribute Show dimension_fields attribute object
        • limit number

          [preview] This functionality is in technical preview and may be changed or removed in a future release. Elastic will work to fix any issues, but features in technical preview are not subject to the support SLA of official GA features.

      • source object
      • ignore_malformed boolean | string

    • indexing.slowlog object
      Hide indexing.slowlog attributes Show indexing.slowlog attributes object
      • level string
      • source number
      • reformat boolean
      • threshold object
    • indexing_pressure object

      Configure indexing back pressure limits.

      Hide indexing_pressure attribute Show indexing_pressure attribute object
      • memory object Required
        Hide memory attribute Show memory attribute object
        • limit number

          Number of outstanding bytes that may be consumed by indexing requests. When this limit is reached or exceeded, the node will reject new coordinating and primary operations. When replica operations consume 1.5x this limit, the node will reject new replica operations. Defaults to 10% of the heap.

    • store object

      The store module allows you to control how index data is stored and accessed on disk.

      Hide store attributes Show store attributes object
      • type string

        Any of:

        Values are fs, niofs, mmapfs, or hybridfs.

      • allow_mmap boolean

        You can restrict the use of the mmapfs and the related hybridfs store type via the setting node.store.allow_mmap. This is a boolean setting indicating whether or not memory-mapping is allowed. The default is to allow it. This setting is useful, for example, if you are in an environment where you can not control the ability to create a lot of memory maps so you need disable the ability to use memory-mapping.

      • stats_refresh_interval string

        How often store statistics are refreshed

        External documentation
  • indices string | array[string]

    A comma-separated list of indices and data streams to restore. It supports a multi-target syntax. The default behavior is all regular indices and regular data streams in the snapshot.

    You can't use this parameter to restore system indices or system data streams. Use feature_states instead.

  • partial boolean

    If false, the entire restore operation will fail if one or more indices included in the snapshot do not have all primary shards available.

    If true, it allows restoring a partial snapshot of indices with unavailable shards. Only shards that were successfully included in the snapshot will be restored. All missing shards will be recreated as empty.

    Default value is false.

  • rename_pattern string

    A rename pattern to apply to restored data streams and indices. Data streams and indices matching the rename pattern will be renamed according to rename_replacement.

    The rename pattern is applied as defined by the regular expression that supports referencing the original text, according to the appendReplacement logic.

    External documentation
  • rename_replacement string

    The rename replacement string that is used with the rename_pattern.

Responses

  • 200 application/json
    Hide response attributes Show response attributes object
    • accepted boolean
    • snapshot object
      Hide snapshot attributes Show snapshot attributes object
      • indices array[string] Required
      • snapshot string Required
      • shards object Required
        Hide shards attributes Show shards attributes object
        • failed number Required

          The number of shards the operation or search attempted to run on but failed.

        • successful number Required

          The number of shards the operation or search succeeded on.

        • total number Required

          The number of shards the operation or search will run on overall.

        • failures array[object]
        • skipped number
POST /_snapshot/{repository}/{snapshot}/_restore
curl \
 --request POST 'http://api.example.com/_snapshot/{repository}/{snapshot}/_restore' \
 --header "Content-Type: application/json" \
 --data '"{\n  \"indices\": \"index_1,index_2\",\n  \"ignore_unavailable\": true,\n  \"include_global_state\": false,\n  \"rename_pattern\": \"index_(.+)\",\n  \"rename_replacement\": \"restored_index_$1\",\n  \"include_aliases\": false\n}"'
Request examples
Run `POST /_snapshot/my_repository/snapshot_2/_restore?wait_for_completion=true`. It restores `index_1` and `index_2` from `snapshot_2`. The `rename_pattern` and `rename_replacement` parameters indicate any index matching the regular expression `index_(.+)` will be renamed using the pattern `restored_index_$1`. For example, `index_1` will be renamed to `restored_index_1`.
{
  "indices": "index_1,index_2",
  "ignore_unavailable": true,
  "include_global_state": false,
  "rename_pattern": "index_(.+)",
  "rename_replacement": "restored_index_$1",
  "include_aliases": false
}
Close `index_1` then run `POST /_snapshot/my_repository/snapshot_2/_restore?wait_for_completion=true` to restore an index in-place. For example, you might want to perform this type of restore operation when no alternative options surface after the cluster allocation explain API reports `no_valid_shard_copy`.
{
  "indices": "index_1"
}